﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TCPEssentials.DataTools
{
	public class IASQueryTools
	{
		public static byte[] Create(IASQuery toCreateFrom, Encoding toEncodeIn)
		{
			List<byte[]> ToCombine = new List<byte[]>();
			ToCombine.Add(BitConverter.GetBytes(toCreateFrom.Args.Length));

			foreach (int i in toCreateFrom.Args)
			{
				ToCombine.Add(BitConverter.GetBytes(i));
			}

			ToCombine.Add(toEncodeIn.GetBytes(toCreateFrom.Command));
			return BATools.Combine(ToCombine);
		}

		public static IASQuery Parse(byte[] toParse, Encoding encoding)
		{
			byte[] CountBytes = new byte[4];
			Array.Copy(toParse, CountBytes, 4);
			int Count = BitConverter.ToInt32(CountBytes, 0);
			int[] ArgInts = new int[Count];

			for (int i = 1; i < Count + 1; i++)
			{
				List<byte> ConvList = new List<byte>();
				for (int j = i * 4; j < i * 4 + 4; j++)
				{
					ConvList.Add(toParse[j]);
				}

				int ArgInt = BitConverter.ToInt32(ConvList.ToArray(), 0);
				ArgInts[i - 1] = ArgInt;
			}

			int StartingStringCount = Count * 4 + 4;
			string Command = "";
			Command = encoding.GetString(toParse, StartingStringCount, toParse.Length - StartingStringCount);

			return new IASQuery(ArgInts, Command);
		}
	}

	public class IASQuery
	{
		public int[] Args { get; private set; }
		public string Command { get; private set; }

		public IASQuery(int[] intArgs, string command)
		{
			Args = intArgs;
			Command = command;
		}
	}
}